# Release Instructions

This document explains the release procedure for the Tsync product.

## Procedure

Be sure to do everything in a carbon workspace, you can see how to setup one
[here](https://bitbucket.org/spectracom/matchbox-manifest/src/master/README.md).

To prepare the version commit + tag version you need to:

  * Use the command:  
    `./build/jenkins_dsl_jobs/build_scripts/tsync-release.sh --set-tag <version>`  
    to set the correct version for every file.
  * Create a branch / commit the version modification, create your PR and wait
    for the merge.
  * Once it's done, you can put the tag and push it.
    The script will tell you what to type for that and you can push it with:  
    `git push origin <tag>`  
    **WARNING**: To avoid CI issues, please don't do retag (deleting a tag &
    recreate it).
    If it is necessary, please see with CI maintainers how to do it safely.
  * When your tag is set, go on Jenkins to build your version with the
    [tsync-release](http://jenkins.dev.orolia.com/view/Releases/job/tsync-release/)
    job.
    Select your tag + the previous tag and let the job take care of everything.

## Manual mode

If jenkins is unavailable when you need to release a version, you can use the
release script in standalone by calling it with the command:

```
./build/jenkins_dsl_jobs/build_scripts/tsync-release.sh
```

This will create the file `tsync.tar.xz` in your current directory which you
will need to send on the
[release](http://release.dev.orolia.com/software-versions/tsync/) server.
