#ifndef TSYNC_SWITCH_SERVICE
#define TSYNC_SWITCH_SERVICE

#define TSYNC_ID_SW 0x4B
#define TSYNC_ID_SW_CA_SWITCH_IO 0x01
#define TSYNC_ID_SW_CA_SWITCH_OPTIONS_AMOUNT 0x02
#define TSYNC_ID_SW_CA_SWITCH_GET_OPTION 0x03
#define TSYNC_ID_SW_CA_SWITCH_IO_NUM 0x04


#define SW_IO_SWITCH_VALUE_FIELDS \
    TSYNC_X(uint8_t, feature)     \
    TSYNC_X(uint8_t, type)        \
    TSYNC_X(uint8_t, io)          \
    TSYNC_X(uint8_t, instance)

#define SW_IO_SWITCH_GET_CMD_FIELDS \
    TSYNC_X(uint32_t, io)

#define SW_IO_SWITCH_OPTIONS_AMOUNT_VALUE_FIELDS \
    TSYNC_X(uint32_t, total)

#define SW_IO_SWITCH_OPTION_VALUE_FIELDS \
    TSYNC_X_BUFFER(char, value, SWITCH_FEATURE_OPTION_LEN)

#define SW_IO_SWITCH_GET_OPTION_VALUE_FIELDS \
    TSYNC_X(uint32_t, index)

#define SW_IO_SWITCH_IO_NUM_VALUE_FIELDS \
    TSYNC_X(uint32_t, total)

#include "tsync_struct_define.h"
GEN_STRUCT(SW_IO_SWITCH_VALUE)
GEN_STRUCT(SW_IO_SWITCH_GET_CMD)
GEN_STRUCT(SW_IO_SWITCH_OPTIONS_AMOUNT_VALUE)
GEN_STRUCT(SW_IO_SWITCH_OPTION_VALUE)
GEN_STRUCT(SW_IO_SWITCH_GET_OPTION_VALUE)
GEN_STRUCT(SW_IO_SWITCH_IO_NUM_VALUE)
#include "tsync_struct_undef.h"

#endif  /* TSYNC_SWITCH_SERVICE */
