#include "tsync.h"

#include <stdlib.h>
#include <stdio.h>


int main(int argc, char* argv[])
{
    if (argc != 3)
    {
        printf(" Usage: SW_GetOption <device> <option index>\n");
        return EXIT_FAILURE;
    }

    int devId = atoi(argv[1]);

    char deviceName[32] = {0};
    sprintf(deviceName, "/dev/tsyncpci%d", devId);

    TSYNC_BoardHandle pHandle;

    if (TSYNC_open(&pHandle, deviceName) != TSYNC_SUCCESS)
    {
        printf("%s: Could not open <%s>\n", argv[0], deviceName);
        return EXIT_FAILURE;
    }

    TSYNC_SwitchOptionObj obj;
    uint32_t optionIndex = atoi(argv[2]);

    TSYNC_ERROR err = TSYNC_SW_getSwitchOption(pHandle, &obj, optionIndex);

    if (err != TSYNC_SUCCESS)
    {
        printf("  Error: %s.\n", tsync_strerror(err));
        return EXIT_FAILURE;
    }

    printf("Value: %s\n", obj.value);
    return EXIT_SUCCESS;
}