#include "tsync.h"

#include <stdlib.h>
#include <stdio.h>


int main(int argc, char* argv[])
{
    if (argc != 2)
    {
        printf(" Usage: SW_GetOptionsAmount <device>\n");
        return EXIT_FAILURE;
    }

    int devId = atoi(argv[1]);

    char deviceName[32] = {0};
    sprintf(deviceName, "/dev/tsyncpci%d", devId);

    TSYNC_BoardHandle pHandle;

    if (TSYNC_open(&pHandle, deviceName) != TSYNC_SUCCESS)
    {
        printf("%s: Could not open <%s>\n", argv[0], deviceName);
        return EXIT_FAILURE;
    }

    uint32_t optionsAmount;

    TSYNC_ERROR err = TSYNC_SW_getSwitchOptionsAmount(pHandle, &optionsAmount);

    if (err != TSYNC_SUCCESS)
    {
        printf("  Error: %s.\n", tsync_strerror(err));
        return EXIT_FAILURE;
    }

    printf("Total options: %d\n", optionsAmount);
    return EXIT_SUCCESS;
}
